/*
 * Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies). 
 * All rights reserved.
 * This component and the accompanying materials are made available
 * under the terms of "Eclipse Public License v1.0"
 * which accompanies this distribution, and is available
 * at the URL "http://www.eclipse.org/legal/epl-v10.html".
 * 
 * Initial Contributors:
 * Nokia Corporation - Initial contribution
 * 
 * Contributors:
 * 
 * Description: This file is part of com.nokia.tools.variant.editor component.
 */

package com.nokia.tools.variant.editor.cpfInfo;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CPF Information</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getName <em>Name</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getAuthor <em>Author</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getOwner <em>Owner</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getVersion <em>Version</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getPlatform <em>Platform</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getDate <em>Date</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getRelease <em>Release</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getDataFile <em>Data File</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getViewId <em>View Id</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getDescription <em>Description</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getProduct <em>Product</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getCustomer <em>Customer</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getStatus <em>Status</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getOrigin <em>Origin</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getTarget <em>Target</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getRootConfMLPath <em>Root Conf ML Path</em>}</li>
 *   <li>{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getLayerPopupInfoText <em>Layer Popup Info Text</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation()
 * @model
 * @generated
 */
public interface CPFInformation extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Author</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Author</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Author</em>' attribute.
	 * @see #setAuthor(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Author()
	 * @model
	 * @generated
	 */
	String getAuthor();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getAuthor <em>Author</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Author</em>' attribute.
	 * @see #getAuthor()
	 * @generated
	 */
	void setAuthor(String value);

	/**
	 * Returns the value of the '<em><b>Owner</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owner</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owner</em>' attribute.
	 * @see #setOwner(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Owner()
	 * @model
	 * @generated
	 */
	String getOwner();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getOwner <em>Owner</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Owner</em>' attribute.
	 * @see #getOwner()
	 * @generated
	 */
	void setOwner(String value);

	/**
	 * Returns the value of the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Version</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Version</em>' attribute.
	 * @see #setVersion(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Version()
	 * @model
	 * @generated
	 */
	String getVersion();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getVersion <em>Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Version</em>' attribute.
	 * @see #getVersion()
	 * @generated
	 */
	void setVersion(String value);

	/**
	 * Returns the value of the '<em><b>Platform</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Platform</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Platform</em>' attribute.
	 * @see #setPlatform(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Platform()
	 * @model
	 * @generated
	 */
	String getPlatform();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getPlatform <em>Platform</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Platform</em>' attribute.
	 * @see #getPlatform()
	 * @generated
	 */
	void setPlatform(String value);

	/**
	 * Returns the value of the '<em><b>Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Date</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Date</em>' attribute.
	 * @see #setDate(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Date()
	 * @model
	 * @generated
	 */
	String getDate();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getDate <em>Date</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Date</em>' attribute.
	 * @see #getDate()
	 * @generated
	 */
	void setDate(String value);

	/**
	 * Returns the value of the '<em><b>Release</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Release</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Release</em>' attribute.
	 * @see #setRelease(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Release()
	 * @model
	 * @generated
	 */
	String getRelease();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getRelease <em>Release</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Release</em>' attribute.
	 * @see #getRelease()
	 * @generated
	 */
	void setRelease(String value);

	/**
	 * Returns the value of the '<em><b>Data File</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Data File</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data File</em>' attribute.
	 * @see #setDataFile(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_DataFile()
	 * @model
	 * @generated
	 */
	String getDataFile();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getDataFile <em>Data File</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data File</em>' attribute.
	 * @see #getDataFile()
	 * @generated
	 */
	void setDataFile(String value);

	/**
	 * Returns the value of the '<em><b>View Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>View Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>View Id</em>' attribute.
	 * @see #setViewId(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_ViewId()
	 * @model
	 * @generated
	 */
	String getViewId();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getViewId <em>View Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>View Id</em>' attribute.
	 * @see #getViewId()
	 * @generated
	 */
	void setViewId(String value);

	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Description()
	 * @model
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Product</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Product</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Product</em>' attribute.
	 * @see #setProduct(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Product()
	 * @model
	 * @generated
	 */
	String getProduct();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getProduct <em>Product</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Product</em>' attribute.
	 * @see #getProduct()
	 * @generated
	 */
	void setProduct(String value);

	/**
	 * Returns the value of the '<em><b>Customer</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Customer</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Customer</em>' attribute.
	 * @see #setCustomer(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Customer()
	 * @model
	 * @generated
	 */
	String getCustomer();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getCustomer <em>Customer</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Customer</em>' attribute.
	 * @see #getCustomer()
	 * @generated
	 */
	void setCustomer(String value);

	/**
	 * Returns the value of the '<em><b>Status</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Status</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Status</em>' attribute.
	 * @see #setStatus(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Status()
	 * @model
	 * @generated
	 */
	String getStatus();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getStatus <em>Status</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Status</em>' attribute.
	 * @see #getStatus()
	 * @generated
	 */
	void setStatus(String value);

	/**
	 * Returns the value of the '<em><b>Origin</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Origin</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Origin</em>' attribute.
	 * @see #setOrigin(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Origin()
	 * @model
	 * @generated
	 */
	String getOrigin();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getOrigin <em>Origin</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Origin</em>' attribute.
	 * @see #getOrigin()
	 * @generated
	 */
	void setOrigin(String value);

	/**
	 * Returns the value of the '<em><b>Target</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target</em>' attribute.
	 * @see #setTarget(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_Target()
	 * @model
	 * @generated
	 */
	String getTarget();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getTarget <em>Target</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target</em>' attribute.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(String value);

	/**
	 * Returns the value of the '<em><b>Root Conf ML Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Root Conf ML Path</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Root Conf ML Path</em>' attribute.
	 * @see #setRootConfMLPath(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_RootConfMLPath()
	 * @model
	 * @generated
	 */
	String getRootConfMLPath();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getRootConfMLPath <em>Root Conf ML Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Root Conf ML Path</em>' attribute.
	 * @see #getRootConfMLPath()
	 * @generated
	 */
	void setRootConfMLPath(String value);

	/**
	 * Returns the value of the '<em><b>Layer Popup Info Text</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Layer Popup Info Text</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Layer Popup Info Text</em>' attribute.
	 * @see #setLayerPopupInfoText(String)
	 * @see com.nokia.tools.variant.editor.cpfInfo.CpfInfoPackage#getCPFInformation_LayerPopupInfoText()
	 * @model
	 * @generated
	 */
	String getLayerPopupInfoText();

	/**
	 * Sets the value of the '{@link com.nokia.tools.variant.editor.cpfInfo.CPFInformation#getLayerPopupInfoText <em>Layer Popup Info Text</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Layer Popup Info Text</em>' attribute.
	 * @see #getLayerPopupInfoText()
	 * @generated
	 */
	void setLayerPopupInfoText(String value);

} // CPFInformation
